Subject: bug#16519: 24.3.50; gfile notifications not received in batch mode

From: Eli Zaretskii <[email-masked]>
Date: Fri, 31 Jan 2014 18:53:58 +0200

> From: Michael Albinus <[email-masked]>
> Cc: [email-masked]
> Date: Fri, 31 Jan 2014 17:00:18 +0100
> 
> > I don't see why we would need a separate queue for special events.
> > What we need, perhaps, is a way to peek at stdin to see whether
> > there's some input ready to be gobbled.  Shouldn't select/pselect
> > already provide that?  IOW, there should be no need to call getchar at
> > all at this point.
> 
> Reading file notifications via gio does not use file descriptors, which
> are handled via xg_select. The same will happen, if we switch to gdbus
> or kdbus later on. That's why we might need another kind of mainloop integration.

That just means we should call xg_select etc. in addition to calling
pselect.  The events that come that way should still be put on the
same single queue, IMO.

> I'm not too familiar with kbd_buffer_store_event and the mechanisms
> behind.

Basically, all the events that come in are put on that queue, and then
when we need to read input we look at that queue and take events off
it to process.